package MT::Plugin::MTFCKeditor;
### MTFCKeditor - MovableType WYSIWYG Editor with FCKeditor

use strict;

use vars qw( $MYNAME $VERSION );
$MYNAME = 'MTFCKeditor';
$VERSION = '0.01 EMBRYO';

use base qw( MT::Plugin );
my $plugin = new MT::Plugin ({
        name => $MYNAME,
        version => $VERSION,
        author_name => 'Open MagicVox.net',
        author_link => "http://www.magicvox.net/?$MYNAME",
        doc_link => "http://www.magicvox.net/?$MYNAME",
        description => <<PERLHEREDOC,
MovableType WYSIWYG Editor with <a href="http://www.fckeditor.net/">FCKeditor</a>
PERLHEREDOC
#        config_link => "mt-$MYNAME.cgi",
});
MT->add_plugin ($plugin);

sub instance { $plugin; }



### Register callbacks for 3.2 + BigPAPI will be coming soon...
### Register callbacks for 3.3
MT->add_callback ('MT::App::CMS::AppTemplateSource.edit_entry', 1, $plugin, \&edit_entry_js);



###
sub edit_entry_js {
	my ($cb, $app, $template) = @_;
#
	my $old = quotemeta (<<HTMLHEREDOC);
<TMPL_INCLUDE NAME="footer.tmpl">
HTMLHEREDOC
    my $add = <<HTMLHEREDOC;
<script type="text/javascript" src="<TMPL_VAR NAME=STATIC_URI>$MYNAME/fckeditor.js"></script>
<script type="text/javascript">
<!--
function ${MYNAME}_E (id) { return document.getElementById(id); }

function FCKeditor_OnComplete (editorInstance) {
  editorInstance.Events.AttachEvent ('OnBlur', FCKeditor_OnBlur);
  editorInstance.Events.AttachEvent ('OnFocus', FCKeditor_OnFocus);
}

function FCKeditor_OnBlur (editorInstance) {
  editorInstance.ToolbarSet.Collapse ();
}

function FCKeditor_OnFocus (editorInstance) {
  editorInstance.ToolbarSet.Expand ();
}

function ${MYNAME}_OnLoad () {
  // text
  if (${MYNAME}_E ('text')) {
    var oFCKeditor_text = new FCKeditor ('text');
    with (oFCKeditor_text) {
      Config['ToolbarStartExpanded'] = false;
      BasePath        = '<TMPL_VAR NAME=STATIC_URI>${MYNAME}/';
      ToolbarSet      = 'Basic';
      Config['ToolbarStartExpanded'] = false;
      ReplaceTextarea ();
    }
  }

  // text_more
  if (${MYNAME}_E ('text_more')) {
    var oFCKeditor_text_more = new FCKeditor ('text_more');
    with (oFCKeditor_text_more) {
      Config['ToolbarStartExpanded'] = false;
      BasePath        = '<TMPL_VAR NAME=STATIC_URI>${MYNAME}/';
      ToolbarSet      = 'Basic';
      ReplaceTextarea ();
    }
  }
}
${MYNAME}_OnLoad ();
//-->
</script>
HTMLHEREDOC
	$$template =~ s/($old)/$add$1/;
}

1;